Bug 819353 - PTLib Possible deadlock in read/write mutex message
PTLib Possible deadlock in read/write mutex message
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: ptlib (Show other bugs)
16
i386 Linux
unspecified Severity medium
: ---
: ---
Assigned To: Peter Robinson
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-05-06 17:27 EDT by John Bradshaw
Modified: 2013-02-13 16:01 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-02-13 16:01:18 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description John Bradshaw 2012-05-06 17:27:44 EDT
Description of problem:
Ekiga is locking up during calls, when running ekiga from console a warning about a possible deadlock appears.

Version-Release number of selected component (if applicable):
ekiga-3.3.2-3.fc16.i686
opal-3.10.2-4.fc16.i686
ptlib-2.10.2-1.fc16.i686


How reproducible:
Always with current config (SIP connection to Asterisk)

Steps to Reproduce:
1. run ekiga (from console to see messages, also locks if launched via GUI)
2. Configure and register a SIP account to server
3. Attempt a call - GUI will lock up and produce warning messages.
  
Actual results:
[john@opti ~]$ ekiga
     osutils.cxx(2285)	PTLib	Possible deadlock in read/write mutex:
  thread-id=2962574144, readers=0, writers=1
  thread-id=3070479168, readers=0, writers=1
  thread-id=3071277888, readers=1, writers=0

     osutils.cxx(2285)	PTLib	Possible deadlock in read/write mutex:
  thread-id=2962574144, readers=0, writers=1
  thread-id=3070479168, readers=1, writers=0

     osutils.cxx(2285)	PTLib	Possible deadlock in read/write mutex:
  thread-id=2962574144, readers=0, writers=1
  thread-id=3070479168, readers=0, writers=1
  thread-id=3071277888, readers=1, writers=0

     osutils.cxx(2285)	PTLib	Possible deadlock in read/write mutex:
  thread-id=2962574144, readers=0, writers=1
  thread-id=3074157376, readers=1, writers=0

     osutils.cxx(2285)	PTLib	Possible deadlock in read/write mutex:
  thread-id=2962041664, readers=0, writers=1
  thread-id=2962307904, readers=0, writers=1
  thread-id=3078146176, readers=0, writers=1

     osutils.cxx(2285)	PTLib	Possible deadlock in read/write mutex:
  thread-id=2962041664, readers=0, writers=1
  thread-id=2962307904, readers=0, writers=1
  thread-id=3078146176, readers=0, writers=1

^CKilled
[john@opti ~]$ ekiga
     osutils.cxx(2285)	PTLib	Possible deadlock in read/write mutex:
  thread-id=2962574144, readers=0, writers=1
  thread-id=3070479168, readers=0, writers=1

     osutils.cxx(2285)	PTLib	Possible deadlock in read/write mutex:
  thread-id=2962574144, readers=0, writers=1
  thread-id=3070479168, readers=1, writers=0
  thread-id=3071011648, readers=1, writers=0
  thread-id=3071277888, readers=1, writers=0
  thread-id=3078260864, readers=1, writers=0

     osutils.cxx(2285)	PTLib	Possible deadlock in read/write mutex:
  thread-id=2962574144, readers=0, writers=1
  thread-id=3074157376, readers=1, writers=0

^CKilled
[john@opti ~]$ ekiga
     osutils.cxx(2285)	PTLib	Possible deadlock in read/write mutex:
  thread-id=2961922880, readers=1, writers=0
  thread-id=3069946688, readers=0, writers=1
  thread-id=3070479168, readers=1, writers=0
  thread-id=3070745408, readers=1, writers=0
  thread-id=3077474432, readers=1, writers=0

     osutils.cxx(2285)	PTLib	Possible deadlock in read/write mutex:
  thread-id=2961922880, readers=0, writers=1
  thread-id=3069946688, readers=0, writers=1

     osutils.cxx(2285)	PTLib	Possible deadlock in read/write mutex:
  thread-id=3069946688, readers=0, writers=1
  thread-id=3071277888, readers=1, writers=0

^CKilled



Expected results:
Ekiga will run with no warning messages and not lock up.

Additional info:
From "gdb ekiga" run.  Locked up, hit CTRL-C then entered "where":
#0  0x00111416 in __kernel_vsyscall ()
#1  0x44880c05 in sem_wait@@GLIBC_2.1 () from /lib/libpthread.so.0
#2  0x4f6c0940 in PSemaphore::Wait() () from /usr/lib/libpt.so.2.10.2
#3  0x4f71a486 in PReadWriteMutex::InternalWait(PSemaphore&) const () from /usr/lib/libpt.so.2.10.2
#4  0x4f71b71b in PReadWriteMutex::StartWrite() () from /usr/lib/libpt.so.2.10.2
#5  0x4f720608 in PSafeObject::LockReadWrite() () from /usr/lib/libpt.so.2.10.2
#6  0x4f721418 in PSafePtrBase::EnterSafetyMode(PSafePtrBase::EnterSafetyModeOption) () from /usr/lib/libpt.so.2.10.2
#7  0x4f7215f0 in PSafePtrBase::SetSafetyMode(PSafetyMode) () from /usr/lib/libpt.so.2.10.2
#8  0x4ef1d3ac in Opal::Call::get_remote_connection() () from /usr/lib/ekiga/3.3.2/libekiga.so
#9  0x4ef18b34 in Opal::Call::send_dtmf(char) () from /usr/lib/ekiga/3.3.2/libekiga.so
#10 0x08084917 in ?? ()
#11 0x485e1d4a in ?? () from /usr/lib/libgtk-x11-2.0.so.0
#12 0x44a7f645 in g_closure_invoke () from /lib/libgobject-2.0.so.0
#13 0x44a92860 in ?? () from /lib/libgobject-2.0.so.0
#14 0x44a9b118 in g_signal_emit_valist () from /lib/libgobject-2.0.so.0
#15 0x44a9b464 in g_signal_emit () from /lib/libgobject-2.0.so.0
#16 0x48738403 in ?? () from /usr/lib/libgtk-x11-2.0.so.0
#17 0x485df9f0 in gtk_propagate_event () from /usr/lib/libgtk-x11-2.0.so.0
#18 0x485dfcd8 in gtk_main_do_event () from /usr/lib/libgtk-x11-2.0.so.0
#19 0x489990d9 in ?? () from /usr/lib/libgdk-x11-2.0.so.0
#20 0x4496d62f in g_main_context_dispatch () from /lib/libglib-2.0.so.0
#21 0x4496dd70 in ?? () from /lib/libglib-2.0.so.0
#22 0x4496e3a7 in g_main_loop_run () from /lib/libglib-2.0.so.0
#23 0x485de9df in gtk_main () from /usr/lib/libgtk-x11-2.0.so.0
#24 0x08073f0e in main ()
Comment 1 John Bradshaw 2012-05-06 19:25:10 EDT
Some additional debug info using "ekiga -d 4":

2012/05/07 00:17:58.999	  0:09.088	 Housekeeper:0xb70ffb40	OpalUDP	Setting interface to 172.16.249.64%ppp0
2012/05/07 00:18:12.767	  0:22.856	        Pool:0xb0954b40	PTLib	Possible deadlock in read/write mutex:
  thread-id=2962574144, readers=1, writers=0
  thread-id=3070479168, readers=0, writers=1
  thread-id=3071277888, readers=1, writers=0

2012/05/07 00:18:12.769	  0:22.858	        Pool:0xb703cb40	PTLib	Possible deadlock in read/write mutex:
  thread-id=2962574144, readers=0, writers=1
  thread-id=3070479168, readers=0, writers=1

2012/05/07 00:18:13.322	  0:23.410	Opal Garbage:0xb73beb40	PTLib	Possible deadlock in read/write mutex:
  thread-id=3070479168, readers=0, writers=1
  thread-id=3074157376, readers=1, writers=0
Comment 2 Peter Robinson 2013-01-09 05:41:00 EST
Can you retest this on F-18 or F-17 with ekiga 4.0.0 and associated ptlib/opal release?
Comment 3 John Bradshaw 2013-01-09 10:27:23 EST
Can't test. No longer have any Fedora boxes.
Comment 4 Fedora End Of Life 2013-01-16 11:53:48 EST
This message is a reminder that Fedora 16 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 16. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '16'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 16's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 16 is end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" and open it against that version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 5 Fedora End Of Life 2013-02-13 16:01:22 EST
Fedora 16 changed to end-of-life (EOL) status on 2013-02-12. Fedora 16 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.